'use server'

import { Forecast, LocationType, coordType } from "@/types/types";

//takes address and returns coords in obj as {lat: number, lng: number}
export async function getLocation(searchLocation: string): Promise<coordType>{
    const placesKey = "AIzaSyBf1ip4XogdC6XmbfDhxS_RJDOSieycJpQ";
    const url = `https://maps.googleapis.com/maps/api/geocode/json?address=${searchLocation}&key=${placesKey}`;
    const res = await fetch(url);
    if (!res.ok) {
      throw new Error(`There was an error fetching the data`);
    }
    const data: LocationType = await res.json();
    return data.results[0].geometry.location;
  }

export async function getForecast(geoLocation: coordType): Promise<Forecast> {
    const { lat, lng } = geoLocation;
    const appId = "546911d860cb81f16585f7973b394b70";
    const res = await fetch(
      `https://api.openweathermap.org/data/2.5/weather?lat=${lat}&lon=${lng}&appid=${appId}`
    );
    if (!res.ok) {
      throw new Error(`Failed to fetch the weather data`);
    }
    const data: Forecast = await res.json();
    return data;
  }